import { Api } from "./src/Api";
import { EventTransport, Polling } from "./src/transports";
import { UpdateHandler } from "./src/UpdateHandler";
import { MessageBuilder } from "./src/MessageBuilder";
import * as Keyboard from "./src/KeyboardBuilder";
export declare class Tg {
    private readonly token;
    constructor(token: string);
    eventTransport: EventTransport;
    readonly api: Api;
    readonly updates: UpdateHandler;
    createKeyboard: () => Keyboard.KeyboardBuilder;
    createInlineKeyboard: () => Keyboard.InlineKeyboardBuilder;
    startPolling(): Promise<void>;
}
export { Api as TgApi, Polling as TgPolling, UpdateHandler as TgUpdateHandler, MessageBuilder as TgMessageBuilder, Keyboard as TgKeyboard, };
export { Use as TgUse, Event as TgEvent, Update as TgUpdate, Command as TgCommand, CallbackQuery as TgCallbackQuery } from "./src/UpdateHandlerDecorators";
export * as TgEntity from "./src/types";
export * as TgModel from "./src/models";
export * as TgContext from "./src/contexts";
export * as TgParam from "./src/types/params";
export * as TgAttachment from "./src/models/attachments";
